#include<bits/stdc++.h>
using namespace std;
void ispisi(int a[],int n)
{
    for(int i=0;i<n;i++)
    {
        cout<<a[i]<<" ";
    }
    cout<<endl;
}
int najveci(int a[],int n,int x)
{
    int max=0,rez;
    for(int i=x+1;i<n;i++)
    {
        if(max<a[i])
        {
            max=a[i];
            rez=i;
        }
    }
    return rez;
}
int main()
{
    int n,max=0,x,p=0,y=0;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        if(max<=a[i])
        {
            max=a[i];
            x=i;
        }
    }
    if(n==2)
    {
        swap(a[0],a[1]);
        cout<<a[0]<<" "<<a[1]<<endl;
        return 0;
    }
   else
   {
      while(y<x)
      {
          for(int i=y;i<x;i++)
          {
              if(a[i]<a[x])
                {
                    swap(a[i],a[x]);
                    ispisi(a,n);
                    return 0;
                }
                else if(a[i]==a[x])
                {
                    p=1;
                }
          }
          y=x+1;
          x=najveci(a,n,x);
      }
       if(p==1)
       {
           ispisi(a,n);
           return 0;
       }
       else
       {
           swap(a[n-1],a[n-2]);
           ispisi(a,n);
           return 0;
       }
   }
    return 0;
}